#ifdef GL_ES
precision mediump float;
#endif

uniform float u_time;
uniform vec2 u_resolution;

void mainImage( out vec4 fragColor, in vec2 fragCoord )
{
    // Normalized pixel coordinates (from 0 to 1)
    vec2 uv = (fragCoord - .5 * u_resolution.xy)/u_resolution.y;
    uv = uv * exp(-length(uv)*.8);
    float dx = (sin(uv.x*10.*(10. + sin(u_time * .2))));
    float dy = (tan(uv.y*4.*(10. + cos(.2 * u_time))));
    float dr = smoothstep(0., .1, .5 + .5 * (dx * dy) - sin(u_time + 10. * fract(3. * (uv.x + uv.y))));
    float dg = smoothstep(0., .1 , .5 + .5 * (dx * dy) - sin(u_time + .5 + 10. * fract(3.1 * (uv.x + uv.y))));
    float db = smoothstep(0., .1, .5 + .5 * (dx * dy) - sin(u_time + 1.0 + 10. * fract(3.2 * (uv.x + uv.y))));
    fragColor = vec4(dr, dg, db, 1.);
}

void main() {
    mainImage(gl_FragColor, gl_FragCoord.xy);
}
